﻿Imports System.IO
Imports System.Collections
Imports System.Xml
Imports OSGeo.OGR
Imports OSGeo.OSR

Public Class Form1
    Public dsiList As New Microsoft.VisualBasic.Collection
    'Public dsi As DataSourceInfo

    Private Sub ФайлToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles ФайлToolStripMenuItem.Click
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            '
            Dim dsi As DataSourceInfo
            dsi = New DataSourceInfo(OpenFileDialog1.FileName)
            If Not (dsi.ds Is Nothing) Then
                dsi.FillNode(TreeView1.Nodes.Add(OpenFileDialog1.FileName))
                dsiList.Add(dsi)
            End If
        End If
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Ogr.RegisterAll()
    End Sub

    Private Sub СохранитьКакToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles СохранитьКакToolStripMenuItem.Click
        If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            '
            Dim XMLDoc As New XmlDocument
            XMLDoc.LoadXml("<?xml version='1.0' ?>" & _
               "<DataSources/>")
            Dim root As XmlElement = XMLDoc.DocumentElement
            Dim i As Integer
            Dim dsi As DataSourceInfo
            For i = 1 To dsiList.Count
                dsi = dsiList.Item(i)
                root.AppendChild(dsi.GetXML(XMLDoc))
                XMLDoc.Save(SaveFileDialog1.FileName)
            Next i
        End If
    End Sub

    Private Sub ДиректорияToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles ДиректорияToolStripMenuItem.Click
        '
        Dim result As DialogResult = FolderBrowserDialog1.ShowDialog()
        Dim folderName As String

        If (result = DialogResult.OK) Then
            folderName = FolderBrowserDialog1.SelectedPath
            If Directory.Exists(folderName) Then
                'Dim fileEntries As String() = Directory.GetFiles(folderName)
                Dim dsi As DataSourceInfo
                Dim di As DirectoryInfo = New DirectoryInfo(folderName)
                Dim fi As FileInfo
                For Each fi In di.GetFiles()
                    'If fi.Extension = ".TAB" Then
                    dsi = New DataSourceInfo(fi.FullName)
                    If Not (dsi.ds Is Nothing) Then
                        dsi.FillNode(TreeView1.Nodes.Add(fi.FullName))
                        dsiList.Add(dsi)
                    End If
                Next
            End If
        End If
    End Sub

    Private Sub TreeView1_NodeMouseClick(sender As System.Object, e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseClick
        Dim chNode As XmlNode
        TextBox1.Clear()
        If Not (e.Node.Tag Is Nothing) Then
            chNode = e.Node.Tag
            TextBox1.Text = chNode.OuterXml
        End If
    End Sub

    Private Sub Test1ToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles Test1ToolStripMenuItem.Click
        If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            '
            Dim XMLDoc As New XmlDocument
            XMLDoc.LoadXml("<?xml version='1.0' ?>" & _
               "<DataSources/>")
            Dim root As XmlElement = XMLDoc.DocumentElement
            Dim i As Integer
            Dim dsi As DataSourceInfo
            For i = 1 To dsiList.Count
                dsi = dsiList.Item(i)
                root.AppendChild(dsi.Gettest1XML(XMLDoc, "Код", "Название"))
                XMLDoc.Save(SaveFileDialog1.FileName)
            Next i
        End If
    End Sub

    Private Sub Test11ToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles Test11ToolStripMenuItem.Click
        test1_form.Show()
    End Sub
End Class
